var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.findSuitableTask=exports.executeTask=exports.initializeTask=exports.getEngineRunner=exports.getEngineByPlatform=exports.registerEngine=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _logger=require("../systemManager/logger");
var _common=require("../common");
var _analytics=_interopRequireDefault(require("../systemManager/analytics"));
var _buildHooks=require("../projectManager/buildHooks");


var _prompt=require("../../cli/prompt");

var REGISTERED_ENGINES=[];
var ENGINES={};
var ENGINE_CORE='engine-core';

var registerEngine=function registerEngine(engine){
ENGINES[engine.getId()]=engine;
REGISTERED_ENGINES.push(engine);
};exports.registerEngine=registerEngine;

var getEngineByPlatform=function getEngineByPlatform(c,platform,ignoreMissingError){
var selectedEngineKey;
if(c.buildConfig&&!!platform){var _c$files$rnv$engines$,_c$files$rnv$engines$2;
selectedEngineKey=(0,_common.getConfigProp)(c,platform,'engine');
var selectedEngine=(_c$files$rnv$engines$=c.files.rnv.engines.config)==null?void 0:(_c$files$rnv$engines$2=_c$files$rnv$engines$.engines)==null?void 0:_c$files$rnv$engines$2[selectedEngineKey];
if(!selectedEngine&&!ignoreMissingError){
(0,_logger.logDebug)("ERROR: Engine: "+selectedEngineKey+" does not exists or is not registered "+new Error());

}
return selectedEngine;
}
return null;
};exports.getEngineByPlatform=getEngineByPlatform;


var getEngineRunner=function getEngineRunner(c,task){
var selectedEngine=getEngineByPlatform(c,c.platform);
if(!selectedEngine){
if(ENGINES[ENGINE_CORE].hasTask(task))return ENGINES[ENGINE_CORE];

throw new Error("Cound not find suitable executor for task "+(0,_logger.chalk)().white(task));
}
var engine=ENGINES[selectedEngine==null?void 0:selectedEngine.id];
if(!engine){
if(ENGINES[ENGINE_CORE].hasTask(task))return ENGINES[ENGINE_CORE];
throw new Error("Cound not find active engine with id "+(selectedEngine==null?void 0:selectedEngine.id)+". Available engines:\n        "+
Object.keys(ENGINES).join(', '));
}
if(engine.hasTask(task))return engine;
if(ENGINES[ENGINE_CORE].hasTask(task))return ENGINES[ENGINE_CORE];

throw new Error("Cound not find suitable executor for task "+(0,_logger.chalk)().white(task));
};exports.getEngineRunner=getEngineRunner;

var initializeTask=function initializeTask(c,task){return _regenerator.default.async(function initializeTask$(_context){while(1){switch(_context.prev=_context.next){case 0:
c.runtime.task=task;

_analytics.default.captureEvent({
type:task+"Project",
platform:c.platform});return _context.abrupt("return",


executeTask(c,task,null,task));case 3:case"end":return _context.stop();}}},null,null,null,Promise);};exports.initializeTask=initializeTask;


var _executePipe=function _executePipe(c,task,phase){var subCmd;return _regenerator.default.async(function _executePipe$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
subCmd='';
if(c.subCommand){
subCmd=":"+c.subCommand;
}return _context2.abrupt("return",
(0,_buildHooks.executePipe)(c,""+task+subCmd+":"+phase));case 3:case"end":return _context2.stop();}}},null,null,null,Promise);};


var executeTask=function executeTask(c,task,parentTask,originTask){var pt,prt;return _regenerator.default.async(function executeTask$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
pt=parentTask?" => ["+parentTask+"]":'';
c._currentTask=task;
(0,_logger.logInitTask)("executeTask"+pt+" => ["+task+"]");if(!(
c.program.only&&!!parentTask)){_context3.next=7;break;}
(0,_logger.logTask)('executeTask',"task:"+task+" parent:"+parentTask+" origin:"+originTask+" SKIPPING...");_context3.next=13;break;case 7:_context3.next=9;return _regenerator.default.awrap(


_executePipe(c,task,'before'));case 9:_context3.next=11;return _regenerator.default.awrap(
getEngineRunner(c,task).executeTask(c,task,parentTask,originTask));case 11:_context3.next=13;return _regenerator.default.awrap(
_executePipe(c,task,'after'));case 13:

c._currentTask=parentTask;
prt=parentTask?"["+parentTask+"]":'';
(0,_logger.logExitTask)(prt+" <= "+task);case 16:case"end":return _context3.stop();}}},null,null,null,Promise);};exports.executeTask=executeTask;


var _getTaskOption=function _getTaskOption(_ref){var taskInstance=_ref.taskInstance,hasMultipleSubTasks=_ref.hasMultipleSubTasks;
if(hasMultipleSubTasks){
return taskInstance.task.split(' ')[0]+"...";
}
if(taskInstance.description&&taskInstance.description!==''){
return taskInstance.task.split(' ')[0]+" "+(0,_logger.chalk)().grey("("+taskInstance.description+")");
}
return""+taskInstance.task.split(' ')[0];
};

var findSuitableTask=function findSuitableTask(c){var suitableTaskInstances,taskInstances,tasks,defaultCmd,tasksCommands,filteredTasks,_await$inquirerPrompt,command,task,suitableEngines,supportedSubtasks,subTasks,_await$inquirerPrompt2,subCommand,supportedPlatforms,platforms,_await$inquirerPrompt3,platform;return _regenerator.default.async(function findSuitableTask$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:if(
c.command){_context4.next=11;break;}
suitableTaskInstances={};
REGISTERED_ENGINES.forEach(function(engine){
engine.getTasks().forEach(function(taskInstance){
var key=taskInstance.task.split(' ')[0];
var hasMultipleSubTasks=false;
if(taskInstance.task.includes(' '))hasMultipleSubTasks=true;
suitableTaskInstances[key]={
taskInstance:taskInstance,
hasMultipleSubTasks:hasMultipleSubTasks};

});
});
taskInstances=Object.values(suitableTaskInstances);

defaultCmd='new';


if(!c.paths.project.configExists){
filteredTasks=taskInstances.filter(function(v){return v.taskInstance.skipProjectSetup;});
tasks=filteredTasks.map(function(v){return _getTaskOption(v);}).sort();
tasksCommands=filteredTasks.map(function(v){return v.taskInstance.task.split(' ')[0];}).sort();
}else{
tasks=taskInstances.map(function(v){return _getTaskOption(v);}).sort();
tasksCommands=taskInstances.map(function(v){return v.taskInstance.task.split(' ')[0];}).sort();
defaultCmd='run';
}_context4.next=8;return _regenerator.default.awrap(

(0,_prompt.inquirerPrompt)({
type:'list',
default:defaultCmd,
name:'command',
message:'Pick a command',
choices:tasks,
pageSize:15,
logMessage:'You need to tell rnv what to do. NOTE: your current directory is not ReNative project. RNV options will be limited'}));case 8:_await$inquirerPrompt=_context4.sent;command=_await$inquirerPrompt.command;

c.command=tasksCommands[tasks.indexOf(command)];case 11:

task=c.command;
if(c.subCommand)task+=" "+c.subCommand;

suitableEngines=REGISTERED_ENGINES.filter(function(engine){return engine.hasTask(task);});if(

suitableEngines.length){_context4.next=25;break;}
supportedSubtasks={};
REGISTERED_ENGINES.forEach(function(engine){
engine.getSubTasks(task).forEach(function(taskInstance){
var taskKey=taskInstance.task.replace(task,'').trim();
var desc=taskInstance.description?"("+taskInstance.description+")":'';
var key=taskKey+" "+(0,_logger.chalk)().grey(desc);
supportedSubtasks[key]={
taskKey:taskKey};

});
});
subTasks=Object.keys(supportedSubtasks);if(!
subTasks.length){_context4.next=25;break;}_context4.next=21;return _regenerator.default.awrap(
(0,_prompt.inquirerPrompt)({
type:'list',
name:'subCommand',
message:"Pick a subCommand for "+c.command,
choices:subTasks}));case 21:_await$inquirerPrompt2=_context4.sent;subCommand=_await$inquirerPrompt2.subCommand;


c.subCommand=supportedSubtasks[subCommand].taskKey;
task=c.command+" "+c.subCommand;case 25:if(



c.platform){_context4.next=36;break;}
supportedPlatforms={};
suitableEngines.forEach(function(engine){
engine.getTask(task).platforms.forEach(function(plat){
supportedPlatforms[plat]=true;
});
});
platforms=Object.keys(supportedPlatforms);if(!

platforms.length){_context4.next=36;break;}_context4.next=32;return _regenerator.default.awrap(
(0,_prompt.inquirerPrompt)({
type:'list',
name:'platform',
message:"Pick a platform for "+task,
choices:platforms}));case 32:_await$inquirerPrompt3=_context4.sent;platform=_await$inquirerPrompt3.platform;

c.platform=platform;return _context4.abrupt("return",
getEngineRunner(c,task).getTask(task));case 36:return _context4.abrupt("return",


getEngineRunner(c,task).getTask(task));case 37:case"end":return _context4.stop();}}},null,null,null,Promise);};exports.findSuitableTask=findSuitableTask;
//# sourceMappingURL=index.js.map