var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.taskRnvProjectConfigure=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _pluginManager=require("../core/pluginManager");
var _logger=require("../core/systemManager/logger");
var _configParser=require("../core/configManager/configParser");



var _templateManager=require("../core/templateManager");
var _fileutils=require("../core/systemManager/fileutils");
var _crypto=require("../core/systemManager/crypto");
var _migrator=require("../core/projectManager/migrator");
var _constants=require("../core/constants");
var _projectParser=require("../core/projectManager/projectParser");
var _engineManager=require("../core/engineManager");


var taskRnvProjectConfigure=function taskRnvProjectConfigure(c,parentTask,originTask){return _regenerator.default.async(function taskRnvProjectConfigure$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('taskRnvPlatformConfigure',"parent:"+parentTask+" origin:"+originTask);

if(c.paths.project.builds.dir&&!(0,_fileutils.fsExistsSync)(c.paths.project.builds.dir)){
(0,_logger.logInfo)("Creating folder "+c.paths.project.builds.dir);
(0,_fileutils.fsMkdirSync)(c.paths.project.builds.dir);
}_context.next=4;return _regenerator.default.awrap(
(0,_migrator.checkAndMigrateProject)(c));case 4:_context.next=6;return _regenerator.default.awrap(
(0,_configParser.parseRenativeConfigs)(c));case 6:_context.next=8;return _regenerator.default.awrap(
(0,_configParser.checkIsRenativeProject)(c));case 8:_context.next=10;return _regenerator.default.awrap(
(0,_projectParser.checkAndCreateProjectPackage)(c));case 10:_context.next=12;return _regenerator.default.awrap(
(0,_configParser.taskRnvWorkspaceConfigure)(c));case 12:_context.next=14;return _regenerator.default.awrap(
(0,_templateManager.checkIfTemplateInstalled)(c));case 14:_context.next=16;return _regenerator.default.awrap(
(0,_configParser.fixRenativeConfigsSync)(c));case 16:_context.next=18;return _regenerator.default.awrap(
(0,_engineManager.executeTask)(c,_constants.TASK_INSTALL,_constants.TASK_PROJECT_CONFIGURE,originTask));case 18:_context.next=20;return _regenerator.default.awrap(
(0,_crypto.checkCrypto)(c,parentTask,originTask));case 20:_context.next=22;return _regenerator.default.awrap(
(0,_configParser.configureRuntimeDefaults)(c));case 22:if(!(

originTask!==_constants.TASK_TEMPLATE_APPLY)){_context.next=41;break;}_context.next=25;return _regenerator.default.awrap(
(0,_templateManager.applyTemplate)(c));case 25:_context.next=27;return _regenerator.default.awrap(
(0,_configParser.configureRuntimeDefaults)(c));case 27:_context.next=29;return _regenerator.default.awrap(
(0,_pluginManager.configurePlugins)(c));case 29:_context.next=31;return _regenerator.default.awrap(
(0,_engineManager.executeTask)(c,_constants.TASK_INSTALL,_constants.TASK_PROJECT_CONFIGURE,originTask));case 31:_context.next=33;return _regenerator.default.awrap(
(0,_engineManager.executeTask)(c,_constants.TASK_APP_CONFIGURE,_constants.TASK_PROJECT_CONFIGURE,originTask));case 33:_context.next=35;return _regenerator.default.awrap(
(0,_projectParser.copyRuntimeAssets)(c));case 35:_context.next=37;return _regenerator.default.awrap(
(0,_templateManager.configureEntryPoints)(c));case 37:_context.next=39;return _regenerator.default.awrap(
(0,_configParser.generateRuntimeConfig)(c));case 39:_context.next=41;return _regenerator.default.awrap(
(0,_pluginManager.overrideTemplatePlugins)(c));case 41:return _context.abrupt("return",


true);case 42:case"end":return _context.stop();}}},null,null,null,Promise);};exports.taskRnvProjectConfigure=taskRnvProjectConfigure;var _default=


{
description:'Configure current project',
fn:taskRnvProjectConfigure,
task:_constants.TASK_PROJECT_CONFIGURE,
params:[],
platforms:[]};exports.default=_default;
//# sourceMappingURL=task.rnv.project.configure.js.map